/**
 * @(#)AList.java  6 November 2006
 *
 * @author Viera K. Proulx
 */

/**
 * An abstract class to represent a list of cities.
 * Implements the <CODE>{@link Traversal Traversal}</CODE>
 * interface.
 */
public abstract class AList<T> implements Traversal<T>{
  
  /**
   * Produce a traversal for the rest of this data set. 
   */
  abstract public Traversal<T> getRest(); 
  
  /**
   * Select the first item in this data set.
   */
  abstract public T getFirst(); 
  
  /**
   * Test whether there are more items in this data set.
   */
  abstract public boolean isEmpty();       
}

