/**
 * @(#)ComparatorByName  1.0  11 November 2006
 *
 * @author Viera K. Proulx
 */

import java.util.Comparator;
/**
 * A class that represents a comparison of two 
 * <CODE>{@link City City}</CODE> objects by their name and state.
 */
public class ComparatorByName implements Comparator<City>{
  
  /**
   * Compare the two given <CODE>{@link City City}</CODE> objects 
   * by their name and state.
   * 
   * @param city1 the first <CODE>{@link City City}</CODE> object
   * @param city2 the second <CODE>{@link City City}</CODE> object
   * @return 
   * <p> negative value if city1 is before city2 in this ordering</p>
   * <p> negative value if city1 is the same as city2 in this ordering</p>
   * <p> positive value if city1 is after city2 in this ordering</p>
   */ 
  public int compare(City city1, City city2){
    int result = city1.name.compareTo(city2.name);
    if (result == 0){
      result = city1.state.compareTo(city2.state);
      if (result == 0)
        return city1.zip - city2.zip;
      else 
        return result;
    }
    else
      return result;
  }
}