/**
 * @(#)ConsList.java  6 November 2006
 *
 * @author Viera K. Proulx
 */
/**
 * A class to represent an nonempty list of data.
 */
public class ConsList<T> extends AList<T>{
  
  /*---------------------------------------------------------------
   Member data
   --------------------------------------------------------------*/
  /** the first item in the new list */
  T         first;
  /** the rest of the new list */
  AList<T> rest;
  
  /*---------------------------------------------------------------
   Constructor
   --------------------------------------------------------------*/
  /**
   * The full constructor
   * 
   * @param first the first city in the new list
   * @param rest the rest of the new list
   */
  ConsList (T first, AList<T> rest) {
    this.first = first;
    this.rest  = rest;
  }
  
  /*---------------------------------------------------------------
   Implementing Traversal
   --------------------------------------------------------------*/
  /**
   * Produce a traversal for the rest of this data set. 
   */
  public Traversal<T> getRest(){ return this.rest; }
 
  /**
   * Select the first item in this data set.
   */
  public T getFirst(){ return this.first; }
  
  /**
   * Test whether there are more items in this data set.
   */
  public boolean isEmpty(){ return false; }

  /*---------------------------------------------------------------
   Print all member data values.
   --------------------------------------------------------------*/
  /**
   * Produce a <CODE>{@link String}</CODE> representation 
   * of this instance.
   */
  public String toString(){
    return("\nnew " + getClass().getName() + "(" + 
        first             + ", " + 
        rest   + ")");
  }
}

